# autor: taoke
# time : 2021/10/11 11:05
"""
基础数据管理

"""
import allure,xlrd,pytest
from config import *
from common.utils.getExcelData import get_excelData
from common.tools import request_main
from common.db import RedisString,MYSQL


@allure.feature("企业端-基础数据管理")
class TestEnterpriseArchives( ):
    workBook = xlrd.open_workbook(f'{BaseConfig.root_path}/test_case_data/safe_transportation/qyd_baseData.xlsx')
    @allure.story("单接口用例")
    @allure.title("{inData[testPoint]}")
    @allure.description("适用单接口")
    @pytest.mark.parametrize("inData", get_excelData(workBook, '基础数据管理', 'common'))
    def test_common(self, inData):
        # 请求
        res = request_main(url=f"{SafeTransportationConfig().test_bmy_host}{inData['url']}",
                           headers=inData['headers'],
                           method=inData['method'],
                           data = inData['reqData'])
        allure.attach(f"{res}", "响应结果", allure.attachment_type.TEXT)
        # 断言
        assert res['code'] == inData['expectData']['code']

    @pytest.mark.usefixtures("del_driverData")
    @allure.story("驾驶人管理")
    @allure.title("{inData[testPoint]}")
    @pytest.mark.parametrize("inData", get_excelData(workBook, '基础数据管理', 'addDriver'))
    def test_addDriver(self, inData):
        res = request_main(url=f"{SafeTransportationConfig().test_bmy_host}{inData['url']}",
                           headers=inData['headers'],
                           method=inData['method'],
                           data=inData['reqData'])
        allure.attach(f"{res}", "响应结果", allure.attachment_type.TEXT)
        assert res['code'] == inData['expectData']['code']

    @pytest.fixture()   # 用做新增驾驶员用例的环境初始化---先把数据删掉
    def del_driverData(self):
        mysql = MYSQL(host="10.197.236.190", port=3306, user="root", pwd="123456", db="edl_private")
        mysql.ExecuNonQuery(
            "DELETE FROM db_tbd.base_transport_driver WHERE license_number='510122202011120001';")

    @pytest.fixture()  # 用做编辑驾驶员用例和删除驾驶员环境初始化---先查询某个驾驶员的id
    def get_driverId(self):
        mysql = MYSQL(host="10.197.236.190", port=3306, user="root", pwd="123456", db="edl_private")
        dirverId = mysql.ExecuQuery(
            "select id from db_tbd.base_transport_driver where license_number='510122202011120001';")
        return dirverId[0]["id"]

    @allure.story("驾驶人管理")
    @allure.title("{inData[testPoint]}")
    @pytest.mark.parametrize("inData", get_excelData(workBook, '基础数据管理', 'updateDelDriver'))
    def test_updateDriver(self,inData,get_driverId):        # 这里的执行顺序为：新增、删除(假删除)、编辑
        """编辑用例和删除用例都适用，需要改用例中的id"""
        inData['reqData']["id"]= get_driverId
        res = request_main(url=f"{SafeTransportationConfig().test_bmy_host}{inData['url']}",
                           headers=inData['headers'],
                           method=inData['method'],
                           data=inData['reqData'])
        allure.attach(f"{res}", "响应结果", allure.attachment_type.TEXT)
        assert res['code'] == inData['expectData']['code']

    """环境恢复"""
    @pytest.fixture(scope="class",autouse=True)
    def del_Data(self):
        yield
        mysql = MYSQL(host="10.197.236.190", port=3306, user="root", pwd="123456", db="edl_private")
        mysql.ExecuNonQuery(
            "DELETE FROM db_tbd.base_transport_driver WHERE license_number='510122202011120001';")      # 删除驾驶员自动化测试数据


if __name__ == '__main__':
    for one in os.listdir('../../../report/tmp'):
        if 'json' or 'txt' in one:
            os.remove(f'../../../report/tmp/{one}')
    pytest.main(['test_baseData.py', '-s', '--alluredir','../../../report/tmp'])
    # 启动默认浏览器打开报告
    os.system('allure serve ../../../report/tmp')